
var C C_e C_p I Y K w R_k L N q R pi lambda_e tau b L_h R_L lambda_mu mc spread_eq m g Gamma z Ksi Ksi_w Psi t_cost
y_obs pi_obs R_obs R_L_obs b_obs L_obs I_obs w_obs c_obs N_obs;

varexo m_u g_u Gamma_u z_u Ksi_u Psi_u t_cost_u Ksi_w_u tau_u R_u;


parameters DiscF gamma Pi_ss beta beta_e sigma delta alpha varphi gamma_k phi_pi phi_y theta gamma_R g_share chi theta_w lambda_w w_param pi_ss
mc_ss R_k_ss l_share c_share c_p_share c_e_share i_share k_share R_ss m_ss tau_ss phi_b b_share R_L_ss v_ac 
rho_Gamma rho_g rho_m rho_z rho_Ksi rho_Psi rho_t_cost rho_Ksi_w
;

//Fixed Parameters
alpha=0.33;     //share of capital in production 
lambda_f=0.1;   //price markup 
lambda_w=0.2;   //wage markup   
delta=0.025;    //depreciation rate (implied 10% depreciation per year)
mc_ss=1/(1+lambda_f);  //steady state marginal cost
g_share=0.15;   //steady state share of government spending
beta_e=0.985;  // discount factor of entrepreneurs 

//Parameter Initialization
//gammaa=2.5;  //400/gamma    
//pia=3; //ss net inflation 400/pi_ss
DiscF=0.004;  //400/(beta^{-1}-1)
                   
theta=0.66;  //degree of price stickiness
theta_w=0.66; //degree of wage stickiness
chi=0.6;     //habit persistence
sigma=2;     //risk aversion            
varphi=2;    //inverse of the frish elasticity of labor supply              
phi_y=0.125;   //response to output in taylor rule        
phi_pi=1.5;  //response to inflation in taylor rule 
phi_b=1.5;   //response of taxes to changes in debt   
gamma_k=4;// investment adjustment cost
gamma_R=0.7; //response to the lag of the interest rate
m_ss=0.33;   //loan-to-value ratio  

rho_g=0.5; 
rho_m=0.5;   
rho_z=0.5;
rho_Gamma=0.5;
rho_Ksi=0.5;
rho_Psi=0.5;
rho_t_cost=0.5;
rho_Ksi_w=0.5;

//Transformed Parameters
gamma=0.00625;
pi_ss=0.0075;
beta=1/(DiscF+1);
w_param=1+((1+lambda_w)/lambda_w)*varphi; //A in the paper
v_ac=0.001;
//Implied Steady State Values

Pi_ss=1+pi_ss;
R_L_ss=(exp(gamma))*Pi_ss/beta;
R_ss=R_L_ss;
lev_ss=R_L_ss/(Pi_ss*m_ss*(1-delta)); //lev_ss=leverage ratio = K/L
R_k_ss=(1-(lev_ss)^(-1)-(exp(-gamma))*beta_e*(1-delta)*(1-m_ss))/beta_e*(exp(-gamma));
k_share=(alpha*mc_ss*(exp(gamma)))/R_k_ss;
i_share=(exp(gamma)-(1-delta))*k_share;
l_share=k_share/lev_ss;
c_e_share=(1-(exp(gamma))*R_L_ss/(Pi_ss))*l_share+((R_k_ss+(1-delta))*(exp(gamma))-1)*k_share;
c_p_share=1-i_share-g_share-c_e_share;
c_share=c_p_share+c_e_share;
b_share=1.68; //implied annual debt to gdp ratio of 0.42 (1.68/4)
tau_ss=b_share*((exp(-gamma))*R_ss/(Pi_ss)-1)+g_share;

//lambda_cc is the SS lagrangian constraint on the collateral equation. It MUST be positive in SS.
//lambda_cc=1/R_L_ss-beta_e;

//log-linearized equilibrium conditions


model(linear);

//Adding gov. b.c. and tax rule only

//Marginal Utility of Consumer
//Internal Habits
//lambda_mu=(1/(1-beta*chi))*(-(sigma/((1-chi))))*((1+beta*chi^2)*C_p-beta*C_p(+1)-chi*C_p(-1));
//External Habits
lambda_mu=-((sigma)/(1-chi))*(C_p-chi*C_p(-1))+Gamma;

//Eulers Bonds
lambda_mu=(lambda_mu(+1)-pi(+1)+R-z(+1))-(v_ac/b_share)*(b-L_h);

//Euler Loans
lambda_mu+t_cost=(lambda_mu(+1)-pi(+1)+R_L-z(+1))+(v_ac/l_share)*(b-L_h);

//Labor Supply
//w-theta_w*(w(-1)-pi)=(((1-theta_w*beta)*(1-theta_w))/(w_param))*(Ksi_w+varphi*(N+((1+lambda_w)/lambda_w)*w)-lambda_mu)+theta_w*beta*(w(+1)-theta_w*(w+pi(+1)));
(w_param/(1-theta_w))*(w-theta_w*(w(-1)-pi-z))=(1-theta_w*(1/(DiscF+1)))*(Ksi_w+varphi*(N+((1+lambda_w)/lambda_w)*w)-lambda_mu)+theta_w*(1/(DiscF+1))*(w_param*(pi(+1)-z(+1))+(w_param/(1-theta_w))*(w(+1)-theta_w*(w-pi(+1)-z(+1))));

//Loan Condition
L=L_h;

//Entrepreneur B.C.
(c_e_share/k_share)*C_e+(1/(1/(DiscF+1)))*(l_share/k_share)*(L(-1)+R_L(-1)-pi)+(q+K)=(l_share/k_share)*L+(R_k_ss+(1-delta))*(exp(-gamma))*(K(-1)-z)+(exp(-gamma))*(R_k_ss*R_k+(1-delta)*q);

//Collateral Constraint
R_L+L=m+q(+1)+K+pi(+1);

//Marginal Utility of Entrepreneur
//Internal Habit
//lambda_e=(1/(1-beta_e*chi))*(-(sigma/((1-chi))))*((1+beta_e*chi^2)*C_e-beta_e*C_e(+1)-chi*C_e(-1));
//External Habits
lambda_e=-((sigma)/(1-chi))*(C_e-chi*C_e(-1));

//Euler Entrepreneur
lambda_e=-q+(exp(-gamma))*beta_e*R_k_ss*(lambda_e(+1)+R_k(+1))+(exp(-gamma))*beta_e*(1-delta)*(lambda_e(+1)+q(+1))+(pi_ss/R_L_ss)*m_ss*(1-delta)*(lambda_e+pi(+1)-R_L+m+q(+1))-(exp(-gamma))*beta_e*m_ss*(1-delta)*(lambda_e(+1)+m+q(+1))+beta_e*(exp(-gamma))*((1-delta)*(m_ss-1)-R_k_ss)*z(+1);  

//Capital Accumulation
K=(exp(-gamma))*(1-delta)*(K(-1)-z)+(1-(1-delta)*(exp(-gamma)))*(I+Psi);

//Investment Decision
I=((1/(DiscF+1))/(1+(1/(DiscF+1))))*I(+1)+(1/(1+(1/(DiscF+1))))*I(-1)+(1/(gamma_k*(1+(1/(DiscF+1)))*(exp(2*gamma))))*(q+Psi);

//Production Function
Y=alpha*(K(-1)-z)+(1-alpha)*N;

//Marginal Cost
mc=alpha*R_k+(1-alpha)*w;

//Optimal Factor Input
w-R_k=K(-1)-z-N;

//Calvo
pi=(((1-(1/(DiscF+1))*theta)*(1-theta))/(theta))*(mc+Ksi)+(1/(DiscF+1))*pi(+1);

//Government Budget Constraint
(b_share/(1/(DiscF+1)))*(b(-1)+R(-1)-pi)+g_share*g=b_share*b+tau_ss*tau;

//Tax Rule
tau=phi_b*b(-1)+tau_u;

//Taylor Rule
R=gamma_R*R(-1)+(1-gamma_R)*(phi_pi*pi+phi_y*Y)+R_u;

//Aggregate resource constraint
C*c_share +i_share*I+g_share*g = Y;

//where consumption 
C*c_share = c_p_share*C_p + c_e_share*C_e;

//Spread
spread_eq=R_L-R;

//Shocks
//LTV            
m=rho_m*(m(-1))+m_u;  
//Government Spending
g=rho_g*(g(-1))+g_u;
//Preferences
Gamma=rho_Gamma*Gamma(-1)+Gamma_u;
//Productivity Trend
z=rho_z*z(-1)+z_u;
//Price Markup
Ksi=rho_Ksi*Ksi(-1)+Ksi_u;
//Investment Shock
Psi=rho_Psi*Psi(-1)+Psi_u;
//wage shock
Ksi_w=rho_Ksi_w*Ksi_w(-1)+Ksi_w_u;
//Transaction Cost Shock
t_cost=rho_t_cost*(t_cost(-1))+t_cost_u;


//8 Measurement equations
y_obs=100*(Y-Y(-1)+gamma);
pi_obs=100*(log(Pi_ss)+pi);
R_obs=100*(log(R_ss)+R);
b_obs=100*(b-b(-1)+gamma);
L_obs=100*(L-L(-1)+gamma);
R_L_obs=100*(log(R_L_ss)+R_L);
w_obs=100*(w-w(-1)+gamma);
c_obs=100*(C-C(-1)+gamma);
I_obs=100*(I-I(-1)+gamma);
N_obs=100*N;
end;


//Check the eigenvalues to see if the Blanchard-Kahn rank condition is satisfied
resid(1);

model_diagnostics;
steady(solve_algo = 1);
check;

//Stochastic shocks
shocks;

var z_u; stderr 0.01; 
var R_u; stderr 0.01;      
var m_u; stderr 0.01;     
var t_cost_u; stderr 0.01; 
var Gamma_u; stderr 0.01;      
var Psi_u; stderr 0.01;
var g_u; stderr 0.01;
var Ksi_u; stderr 0.01;
var Ksi_w_u; stderr 0.01;
var tau_u; stderr 0.01;

end;

estimated_params;
gamma, gamma_pdf, 0.00625, 0.00125;
pi_ss, gamma_pdf, 0.0075, 0.00125;
DiscF, gamma_pdf, 0.0025, 0.000625;
theta, beta_pdf, 0.66, 0.2;
theta_w, beta_pdf, 0.66, 0.2;
chi, beta_pdf, 0.6, 0.1;
sigma, gamma_pdf, 2, 0.5;
varphi, gamma_pdf, 2, 0.1;
phi_pi, gamma_pdf, 1.5, 0.1;
phi_y, gamma_pdf, 0.125, 0.1;
phi_b, gamma_pdf, 1.5, 0.2;
//m_ss, gamma_pdf, 0.33, 0.2;
v_ac, gamma_pdf, 0.005, 0.0025;
gamma_k, gamma_pdf, 4, 1.5;
gamma_R, beta_pdf, 0.7, 0.2;
rho_z, beta_pdf, 0.5, 0.2;
rho_Gamma, beta_pdf, 0.5, 0.2;
rho_Psi, beta_pdf, 0.5, 0.2;
rho_g, beta_pdf, 0.5, 0.2;
rho_m, beta_pdf, 0.5, 0.2;
rho_t_cost, beta_pdf, 0.5, 0.2;
rho_Ksi, beta_pdf, 0.5, 0.1;
rho_Ksi_w, beta_pdf, 0.5, 0.2;

stderr z_u, inv_gamma_pdf, 0.01, inf; 
stderr Gamma_u, inv_gamma_pdf, 0.01, inf; 
stderr Psi_u, inv_gamma_pdf, 0.01, inf; 
stderr g_u, inv_gamma_pdf, 0.01, inf; 
stderr R_u, inv_gamma_pdf, 0.01, inf; 
stderr m_u, inv_gamma_pdf, 0.01, inf; 
stderr t_cost_u, inv_gamma_pdf, 0.01, inf; 
stderr Ksi_u, inv_gamma_pdf, 0.01, inf; 
stderr Ksi_w_u, inv_gamma_pdf, 0.01, inf; 
stderr tau_u, inv_gamma_pdf, 0.01, inf; 

end;

estimated_params_init;
gamma, 0.0044;
pi_ss, 0.0098;
DiscF, 0.0024;
theta, 0.44;
theta_w, 0.41;
chi, 0.55;
sigma, 1.41;
varphi, 2;
phi_pi, 1.54;
phi_y, 0.15;
phi_b, 1.35;
//m_ss, 0.33;
v_ac, 0.0003;
gamma_k, 2.86;
gamma_R, 0.71;
rho_z, 0.01;
rho_m, 0.5;
rho_t_cost, 0.5;
rho_Gamma, 0.5;
rho_Psi, 0.5;
rho_g, 0.94;
rho_Ksi_w,   0.89;
rho_Ksi,     0.35;
stderr z_u, 0.0211; 
stderr R_u, 0.0014; 
stderr m_u, 0.0249; 
stderr t_cost_u, 0.0021; 
stderr Gamma_u, 0.1039; 
stderr Psi_u, 0.32; 
stderr g_u, 0.0305; 
stderr Ksi_w_u, 0.14; 
stderr Ksi_u, 0.03;
stderr tau_u, 0.32;
end;

//Run the Simulation
varobs y_obs pi_obs R_obs R_L_obs b_obs L_obs I_obs w_obs c_obs N_obs;
estimation(datafile=datafd_1987q2_2008q4, mode_check, prefilter=0, mode_compute=4, plot_priors=0, tex, mh_nblocks=2, mh_replic=100000, mh_drop=0.5, mh_jscale=.32, bayesian_irf)  y_obs pi_obs R_obs R_L_obs b_obs L_obs I_obs w_obs c_obs N_obs;
//shock_decomposition y_obs;
stoch_simul(irf=0,conditional_variance_decomposition=[4 8]) y_obs L_obs R_L;
identification; 
dynare_sensitivity(identification=1);